﻿using WorkTime.Models;
using ConsoleTableExt;

namespace WorkTime
{
    internal class Controller
    {
        private readonly CourseContext _context;

        public Controller(CourseContext scheduleContext)
        {
            _context = scheduleContext;
        }

        public void GetWorkers()
        {
            ConsoleTableBuilder.From(_context.Workers.Select(x => new { x.Id, x.Name,x.DateEmployment}).ToList())
                .WithTitle("Workers")
                .ExportAndWriteLine();
        }
        public void GetProject()
        {
            ConsoleTableBuilder.From(_context.Projects.Select(x => new { x.Id, x.Name, x.Ready }).ToList())
                .WithTitle("Workers")
                .ExportAndWriteLine();
        }
        public void GetSalary()
        {
            ConsoleTableBuilder.From(_context.SalaryWithAllowances.Select(x => new { x.Id, x.Name, x.Должность, x.CalcSalary }).ToList())
                .WithTitle("Workers")
                .ExportAndWriteLine();
        }
        public void GetSalaryOnCurrentMonth()
        {
            ConsoleTableBuilder.From(_context.GetSalaryOnCurrentMonths.Select(x => new { x.WorkerId, x.Name, x.Salary, x.Hours}).ToList())
                .WithTitle("Workers")
                .ExportAndWriteLine();
        }
        public void GetPosts()
        {
            ConsoleTableBuilder.From(_context.Posts.Select(x => new { x.Id,x.Name, x.Salary }).ToList())
                .WithTitle("Workers")
                .ExportAndWriteLine();
        }
        public void AddWorker(Worker worker)
        {
            try
            {
                _context.Workers.Add(worker);
                _context.SaveChanges();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.InnerException.Message);
            }
        }
    }
}